//VARIABLES
var currentPosition = 0;
var flyoutIndex = 0;
var news;
var currentFeed = ( (System.Gadget.Settings.read("currentFeed") == "" ) ? 0 : System.Gadget.Settings.read("currentFeed") );
var noItems = ( (System.Gadget.Settings.read("noItems") == "" ) ? 4 : System.Gadget.Settings.read("noItems") );
var t;


//FUNCTIONS


window.onload = function()
{
System.Gadget.settingsUI = "Settings.html";
System.Gadget.onSettingsClosed = settingsClosed;
System.Gadget.onDock = properResizer;
System.Gadget.onUndock = properResizer;
startup();
loadTheme();
}


function properResizer()
{
resizeGadget();
loadTheme();
}


function startup()
{

var isAutoScroll = System.Gadget.Settings.read( "autoScroll" );
if ( isAutoScroll == 1 ) getAutoNews_a();
else
	{
	var refreshTime = System.Gadget.Settings.read('refresh');
	if (refreshTime > 0) getRefreshNews();
	else getNews();
	}
}


function settingsClosed(event)
{
if (event.closeAction == event.Action.commit) 
	{
	clearTimeout(t);
	currentFeed = 0;
	startup();
	loadTheme();
	}
}


function resizeGadget() 
{
	noItems = System.Gadget.Settings.read('noItems');
	if ( noItems == "" ) noItems = 6;
	switch( noItems ) {
		case 4: 
			document.body.style.height = '209px'; 
			message.style.height = '142px';
			break;
		case 6: 
			document.body.style.height = '278px'; 
			message.style.height = '200px';
			break;
		case 8: 
			document.body.style.height = '348px'; 
			message.style.height = '280px';
			break;
	}
	for ( var i = 0; i < noItems; i++ ) document.getElementById(i+'').style.display = 'block';
	for ( var i = noItems; i < 8; i++ ) document.getElementById(i+'').style.display = 'none';
	if ( System.Gadget.docked == true )
	{
	for ( var i = 0; i < noItems; i++ )
		document.getElementById(i+'').className = "feedItemDocked";	
	message.style.width = '118px';
	navigation.style.marginLeft = '8px';
	titleLink.style.width = '130px';
	document.body.style.width = '130px';
	}
	else
	{
	for ( var i = 0; i < noItems; i++ )
		document.getElementById(i+'').className = "feedItemUndocked";
	message.style.width = '355px'; 
	navigation.style.marginLeft = '127px';
	titleLink.style.width = '368px';
	document.body.style.width = '368px';
	}
}


function RSS2Item(itemxml)
{
	this.title;
	this.link;
	this.description;
	this.pubDate;

	var properties = new Array("title", "link", "description", "pubDate");
	var tmpElement = null;
	for (var i=0; i<properties.length; i++)
	{
		tmpElement = itemxml.getElementsByTagName(properties[i])[0];
		if ( tmpElement != null )
			if ( tmpElement.childNodes != null )
				if ( tmpElement.childNodes[0] != null )
					if ( tmpElement.childNodes[0].nodeValue != null )
						eval("this."+properties[i]+"=tmpElement.childNodes[0].nodeValue");
	}
}


function RSS2Channel(rssxml)
{
	this.items = new Array();
	var itemElements = rssxml.getElementsByTagName("item");
	for (var i=0; i<itemElements.length; i++)
	{
	Item = new RSS2Item(itemElements[i]);
	this.items.push(Item);
	}
}


function AtomItem(itemxml)
{
	this.title;
	this.link;
	this.description;
	this.pubDate;
	try { this.title = itemxml.getElementsByTagName("title")[0].childNodes[0].nodeValue; }
	catch (e) { this.title = "(no title)"; }
	try { this.pubDate = itemxml.getElementsByTagName("published")[0].childNodes[0].nodeValue; }
	catch (e) { this.pubDate = null; }
	try { this.description = itemxml.getElementsByTagName("summary")[0].childNodes[0].nodeValue; }
	catch (e) { this.description = null; }
	if ( this.description == null ) 
	{
	try { this.description = itemxml.getElementsByTagName("content")[0].childNodes[0].nodeValue; }
	catch (e) { this.description = "(no summary)"; }
	}
	try 
	{
	var links = itemxml.getElementsByTagName("link");
	for ( var i = 0; i < links.length; i++ ) 
		{
		try { if ( links[i].attributes.getNamedItem("rel").value == "alternate" ) this.link = links[i].attributes.getNamedItem("href").value }
		catch (e) {}
		}
	} catch(e) {}
}


function AtomChannel(atomxml)
{
	this.items = new Array();
	var itemElements;
	try { itemElements = atomxml.getElementsByTagName("feed")[0].getElementsByTagName("entry"); } catch (e) { return false; }
	for ( var i=0; i<itemElements.length; i++ )
	{
	Item = new AtomItem(itemElements[i]);
	this.items.push(Item);
	}	
}

//GEWONE FEEDREFRESH EENMALIG
function getNews()
{
	clear();
	var URL = System.Gadget.Settings.read("feedURL"+currentFeed);
	if ( URL == "" ) 
	{
	titleLink.innerHTML = " rock63";
	showMessage( " </br> </br> ." );
	return true;
	}
	showMessage( "<br /> ..." );
	currentPosition = 0;
	
 	var xmlDocument = new ActiveXObject('Microsoft.XMLDOM');
	xmlDocument.onreadystatechange = function () {
		if (xmlDocument.readyState == 4) 
		{
		if ( xmlDocument.getElementsByTagName("item") != null ) news = new RSS2Channel(xmlDocument);
		else news = new AtomChannel(xmlDocument);
		showNews(news);
		}
	};
	xmlDocument.load(URL);
	return;
}

//SCROLPAGINAS EN FEEDS NA ELKAAR
function getAutoNews_a()
{
	clear();
	var URL = System.Gadget.Settings.read("feedURL"+currentFeed);
	if ( URL == "" ) 
	{
	titleLink.innerHTML = " rock63";
	showMessage( " </br> </br> ." );
	return true;
	}
	showMessage( "<br /> ..." );
	currentPosition = 0;
	
 	var xmlDocument = new ActiveXObject('Microsoft.XMLDOM');
	xmlDocument.onreadystatechange = function () {
		if (xmlDocument.readyState == 4)
		{
		if ( xmlDocument.getElementsByTagName("item") != null ) news = new RSS2Channel(xmlDocument);
		else news = new AtomChannel(xmlDocument);
		showNews(news);
		}
	};
	xmlDocument.load(URL);
	// 600 = 1sec, 180000 = 5min
	t = setTimeout(autoScroller_a, 24000);
	return;
}

function getAutoNews_b()
{
	clear();
	var URL = System.Gadget.Settings.read("feedURL"+currentFeed);
	if ( URL == "" ) 
	{
	titleLink.innerHTML = " rock63";
	showMessage( " </br> </br> ." );
	return true;
	}
	showMessage( "<br /> ..." );
	currentPosition = 0;
	
 	var xmlDocument = new ActiveXObject('Microsoft.XMLDOM');
	xmlDocument.onreadystatechange = function () {
		if (xmlDocument.readyState == 4)
		{
		if ( xmlDocument.getElementsByTagName("item") != null ) news = new RSS2Channel(xmlDocument);
		else news = new AtomChannel(xmlDocument);
		showNews(news);
		}
	};
	xmlDocument.load(URL);
	autoScroller_b();
	return;
}

//REFRESH DE FEED OP DE EERSTE PAGINA
function getRefreshNews()
{
	clear();
	var URL = System.Gadget.Settings.read("feedURL"+currentFeed);
	if ( URL == "" ) 
	{
	titleLink.innerHTML = " rock63";
	showMessage( " </br> </br> ." );
	return true;
	}
	showMessage( "<br /> ..." );
	currentPosition = 0;
	
 	var xmlDocument = new ActiveXObject('Microsoft.XMLDOM');
	xmlDocument.onreadystatechange = function () {
		if (xmlDocument.readyState == 4) 
		{
		if ( xmlDocument.getElementsByTagName("item") != null ) news = new RSS2Channel(xmlDocument);
		else news = new AtomChannel(xmlDocument);
		showNews(news);
		}
	};
	xmlDocument.load(URL);
	jumpto_getRefreshNews();
	return;
}


//TIMEOUT JUMPER
function jumpto_getRefreshNews()
{
	var refreshTime = System.Gadget.Settings.read('refresh');
	// 600 = 1sec, 180000 = 5min
	t = setTimeout(getRefreshNews, refreshTime);
}


function showNews(news)
{
	var name = System.Gadget.Settings.read( "feedName"+currentFeed );
	
	if ( name != "" ) titleLink.innerHTML = name;
	else titleLink.innerHTML = ' rock63';
	
	for ( var i = currentPosition; (i < currentPosition+noItems) && (i < news.items.length); i++ ) 
	{
	item_html = '<a ';
	item_html += (news.items[i].link == null) ? "" : 'href="javascript:void(0)" onclick="flyoutIndex = ' + i + '; showFlyout()">';
	item_html += (news.items[i].title == null ) ? "(no title)</a>" : news.items[i].title + "</a>";
	item_html += (news.items[i].description == null) ? "" : "<br>" + decodeHTML(news.items[i].description);
	document.getElementById( (i-currentPosition) + '' ).innerHTML = item_html;
	}
	var posText = (currentPosition + 1) + '-' + ((currentPosition + noItems)>news.items.length?news.items.length:(currentPosition + noItems)) + '/' + news.items.length;
	position.innerHTML = posText;
	System.Gadget.Settings.write("currentFeed", currentFeed);
	showMessage("");
	return true;
}


function showMessage( msg )
{
	message.style.visibility = "visible";
	messageText.innerHTML = msg;
	if ( msg == "" ) message.style.visibility = "hidden";
}


function loadTheme()
{
	document.styleSheets(1).href = 'styles/style.css';
	resizeGadget();	
	if ( System.Gadget.docked == true )
	{
	System.Gadget.background = "url('../styles/background" + noItems + ".png') no-repeat";
	}
	else
	{
	System.Gadget.background = "url('../styles/background-large" + noItems + ".png') no-repeat";
	}
}


function showFlyout()
{
	if ( flyoutIndex >= news.items.length )
	{
	System.Gadget.Flyout.show = false;
	return true;
	}
	System.Gadget.Flyout.file = "Flyout.html";
	System.Gadget.Flyout.show = true;
}


function clear()
{
	for ( var i = 0; i < 8; i++ )
	document.getElementById(i+'').innerHTML = '';
}


function getNextFeed()
{
	var noFeeds = System.Gadget.Settings.read("noFeeds");
	if ( noFeeds == "" || noFeeds < 2 ) return true;
	currentFeed = (currentFeed+1) % noFeeds;
	getNews();	
}


function getPreviousFeed()
{
	var noFeeds = System.Gadget.Settings.read("noFeeds");
	if ( noFeeds == "" || noFeeds < 2 ) return true;
	currentFeed--;
	if ( currentFeed < 0 ) currentFeed = noFeeds-1;
	getNews();	
}


function decodeHTML(text)
{
	var ctom = /&lt;([^&]*)&gt;/g;
	return text.replace(ctom,"<$1>");
}


function previousPage()
{
	currentPosition = (currentPosition - noItems >= 0) ? currentPosition - noItems : ((news.items.length - news.items.length%noItems)); 
	if ( currentPosition >= news.items.length ) currentPosition -= noItems;
	clear();
	showNews(news);
}


function nextPage()
{
	currentPosition = (currentPosition + noItems) >= news.items.length ? 0 : (currentPosition + noItems); 
	clear();
	showNews(news);

}


function autoScroller_a()
{
	nextPage();
	if ( currentPosition == 0 ) getNextAutoFeed();
	else t = setTimeout(autoScroller_a, 24000);
}


function autoScroller_b()
{
	t = setTimeout(autoScroller_a, 24000);
}


function getNextAutoFeed()
{
	var noFeeds = System.Gadget.Settings.read("noFeeds");
	if ( noFeeds == "" || noFeeds < 2 ) return true;
	currentFeed = (currentFeed+1) % noFeeds;
	getAutoNews_b();	
}

//END OF FILE

