//VARIABLES
System.Gadget.onSettingsClosing = settingsClosing;





//FUNCTIONS
function settingsClosing(event)
{
    if (event.closeAction == event.Action.commit)
    {
        System.Gadget.Settings.write( "refresh", feedRefresh.options[feedRefresh.selectedIndex].value );
	System.Gadget.Settings.write( "noItems", noItems.options[noItems.selectedIndex].value );
	System.Gadget.Settings.write( "autoScroll", ((autoScrollCheckBox.checked == true) ? 1 : 0 ) );
        event.cancel = false;
    }
}


function loadSettings() 
{
	var refresh = System.Gadget.Settings.read("refresh");
	switch ( refresh ) {
		case 60000:
			feedRefresh[0].selected = "1";
			break;
		case 900000:
			feedRefresh[1].selected = "1";
			break;
		default:
			feedRefresh[2].selected = "1";
			break;
		case 3600000:
			feedRefresh[3].selected = "1";
			break;
		case -1:
			feedRefresh[4].selected = "1";
			//break;
	}	
//voor meer dan 1 thema verander hieronder i<1 naar bvb i<2 als je twee themas invoegd	
	for ( var i=0; i<1; i++ ) if ( feedTheme[i].value == theme ) feedTheme[i].selected = "1";
	updatePreview();

	buildFeedList();
	var current = System.Gadget.Settings.read("currentFeed");
	if ( current == "" ) current = 0;
	feeds.options[current].selected = "1";
	
	var isAutoScroll = System.Gadget.Settings.read( "autoScroll" );
	autoScrollCheckBox.checked = (isAutoScroll == 1);
	var items = System.Gadget.Settings.read("noItems");
	if ( items == "" ) items = 4;
	noItems.options[items/2-2].selected = "1";
}


function updatePreview()
{
	previewImage.src = "/drag.png";
}


function buildFeedList()
{
	var n;
	var aux = System.Gadget.Settings.read("noFeeds");
	if ( aux == "" ) n = 0; else n = aux;
	
	for ( var i = 0; i < feeds.options.length; i++ ) feeds.options[i] = null;
	
	for ( var i = 0; i < n; i++ )
	{
		var text = System.Gadget.Settings.read("feedName"+i);
		feeds.options[i] = new Option(text,i+'');
	}
}


function addNewFeed( name, url )
{
	if ( url == "" )
	{
		if ( feedURL.value.replace(/^\s+|\s+$/, '') == "" ) 
		{
			errorMessage.innerHTML = "urlvak is leeg.";
			return true;
		}
		if ( feedName.value.replace(/^\s+|\s+$/, '') == "" )
		{
			errorMessage.innerHTML = "naamvak is leeg.";
			return true;
		}
		url = feedURL.value;
		name = feedName.value;
	}
	
	var n;
	var aux = System.Gadget.Settings.read("noFeeds");
	if ( aux == "" ) n = 0; else n = aux;

	System.Gadget.Settings.write( "feedName"+n, name );	
	System.Gadget.Settings.write( "feedURL"+n, url );	

	n++;
	System.Gadget.Settings.write("noFeeds",n);
	
	feedName.value = "";
	feedURL.value = "";
	errorMessage.innerHTML = "";
	
	buildFeedList();
	feeds.options[feeds.options.length-1].selected = "1";
}


function deleteExistingFeed()
{
	var n;
	var aux = System.Gadget.Settings.read("noFeeds");
	if ( aux == "" ) n = 0; else n = aux;
	
	for ( var i = feeds.selectedIndex; i < n; i++ )	
	{
		var URL = System.Gadget.Settings.read("feedURL"+(i+1));
		var name = System.Gadget.Settings.read("feedName"+(i+1));
		System.Gadget.Settings.write("feedURL"+i, URL);
		System.Gadget.Settings.write("feedName"+i, name);
	}
	
	if ( n > 0 ) n--; else n = 0;
	System.Gadget.Settings.write("noFeeds",n);
	
	buildFeedList();
}


function importFeedsFromIE7() 
{
	var feedManager = null;
	try
	{
		feedManager = new ActiveXObject( "Microsoft.FeedsManager" );
		if ( feedManager == null ) return false;
		searchAndAddFeed( feedManager.RootFolder );
	} catch(e) {}
}


function searchAndAddFeed( folder ) 
{
	var feeds = folder.Feeds;
	for ( var i = 0; i < feeds.Count; i++ )	addNewFeed( feeds.Item(i).Name, feeds.Item(i).Url );
	
	var subFolders = folder.Subfolders;
	for ( var i = 0; i < subFolders.Count; i++ ) searchAndAddFeed( subFolders.Item(i) );
}


function exportFeeds()
{
	var feedManager = null;
	try
	{
		feedManager = new ActiveXObject( "Microsoft.FeedsManager" );
		if ( feedManager == null ) return false;
	} catch(e) {}
	
	var folder = feedManager.RootFolder.CreateSubfolder( " rock63 Gadget Feeds" );
	var n;
	var aux = System.Gadget.Settings.read("noFeeds");
	if ( aux == "" ) n = 0; else n = aux;
	
	for ( var i = 0; i < n; i++ )
	{
		var name = System.Gadget.Settings.read("feedName"+i);
		var url = System.Gadget.Settings.read("feedURL"+i);
		folder.CreateFeed( name, url );
	}
}


function showTable( table )
{
	optionsTable.style.display = 'none';
	aboutTable.style.display = 'none';
	optionsTable.style.display = 'none';
	table.style.display = 'block';
}
